Index: anr/section-ressources.tex
===================================================================
--- anr/section-ressources.tex	(revision 363)
+++ anr/section-ressources.tex	(revision 364)
@@ -56,5 +56,5 @@
             \ifx\cont\tmp\def\cont{None.}\else\def\cont{%
               The costs justified by internal invoicing procedures are evaluated
-              to #5\% of the total requested ANR funding.}\fi
+              to \textbf{#5\%} of the total requested ANR funding.}\fi
               \cont
         %\item[Other working costs] None
@@ -81,5 +81,5 @@
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
-The global effort is 358 \hommemois (\hommemoislong),
+The global effort is \mustbecompleted{XXXXXXXX 358} \hommemois (\hommemoislong),
 the part of academic partners is 236 \hommemois (66\% of the global effort)
 and the part of the industrial partners is 122 \hommemois (\textbf{34\%} of the
@@ -100,26 +100,7 @@
   annexe~\ref{table-livrables-mds} (page \pageref{table-livrables-mds}).
   and a summary by task in the following table.
-   \mustbecompleted{\\MDS: Vous n'etes dans aucuns projets annexe 7.3 ?}
   }
   {2}
   {}
-%  
-% \begin{description}
-% \item[Equipment]
-%   No specific equipment acquisition is required for this project. 
-% \item[Personnel costs]
-%   \mds employees involved in the project are permanent managers, engineers and PhD graduates.
-%   The man power detail in \hommemois by deliverables is given in
-%   annexe~\ref{table-livrables-mds} (page \pageref{table-livrables-mds}).
-%   and a sumary by task in the following table.
-%   \begin{center}\input{table_mds_short.tex}\end{center}
-% \item[Subcontracting]
-%   No subcontracting costs.
-% \item[Travel]
-%   The travel costs are associated to project meeting as well as participation to
-%   conferences. The travel costs are estimated to 2\% of the total requested ANR funding.
-% \item[Expenses for inward billing] none
-% \item[Other working costs] none
-% \end{description}
 
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@@ -133,32 +114,4 @@
    }}
   {8}{3.5}
-% 
-% \begin{description}
-% \item[Equipment]
-%     In order to validate the COACH design flow, \upmc will buy FPGA development
-%     boards (especially 1  PCI/E FPGA \xilinx board).
-%     The cost for these boards is estimated to 6 k\euro (4\% of the total ANR funding).
-% \item[Personnel costs]
-%     The permanent personnels involved in the project are professors or assistant
-%     professors (Alain Greiner and Ivan Aug\'e).
-%     All non permanent personnel costs are estimated in \hommemois for senior researchers
-%     (post-doc or research engineers).
-%     The table below sumarizes the man power by tasks in \hommemois for both permanent  and
-%     non-permanent personnels.
-%     The detail by deliverables is given in annexe~\ref{table-livrables-upmc} (page \pageref{table-livrables-upmc}).
-%     The non-permanent personnels costs (24 \hommemois) represent 46\% of the personnal costs.
-%     The requested funding for non permanent personnels is 79\% of the total ANR
-%     requested funding.
-%     \begin{center}\input{table_upmc_short.tex}\end{center}
-% \item[Subcontracting]
-%     No subcontracting costs.
-% \item[Travel]
-%     The travel costs are associated to management and coordination meeting as
-%     well as participation to conferences. The travel costs are estimated
-%     to 10\% of the total requested ANR funding.
-% \item[Expenses for inward billing]
-%     The costs justified by internal invoicing procedures are evaluated to 4\%
-%     of the total requested ANR funding.
-% \end{description}
 
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@@ -168,40 +121,10 @@
   {ubs}
   {}
-  {{\ubs}{48}{24}{Philippe COUSSY, Cyrille CHAVET and Dominique HELLER}{84}{
+  {{\ubs}{48}{24}{Philippe COUSSY, Cyrille CHAVET and Dominique HELLER}{85}{
    We are looking for profiles with strong informatic skills, good knowledge
    in computer architecture and advanced digital design.
-   \mustbecompleted{\\UBS:  ./gantt < anr.gant\\
-   \t WARNING: ubs       :D511 probleme sur l'an 1 (in table=7.0, in gantt=6.0 \\
-   \t ERROR:   ubs       :D840 probleme sur l'an 1 (in table=0.5, in gantt=0.0}
   }}
-  {11}{4}
-
-% \begin {description}
-% \item [Equipment]
-%   In order to validate the design flow project, the Lab-STICC laboratory will buy FPGA
-%   development boards.  The cost for these FPGA boards is estimated to 3\% of the total
-%   ANR funding.
-% \item [Personnel costs]
-%   The faculty members involved in the project are associate professors (Philippe COUSSY,
-%   Cyrille CHAVET) or research engineers (Dominique HELLER). All non-permanent personnel
-%   costs are estimated in \hommemois for senior researchers (post-doc or research
-%   engineers).
-%   \parlf
-%   The table below summarizes the man power in \hommemois by tasks for both permanent and
-%   non-permanent personnels. The detail by deliverables is given in 
-%   annexe~\ref{table-livrables-usb} (page \pageref{table-livrables-usb}).
-%   The non-permanent personnels costs represent 50\% of the personnel costs.
-%   The requested funding for non permanent personnels is about 83\% of the total ANR
-%   requested funding.
-%     \begin{center}\input{table_ubs_short.tex}\end{center}
-% \item [Subcontracting]
-%   No subcontracting costs.
-% \item [Travel]
-%   The travel costs are associated to management and meeting as well as participation to
-%   conferences. The travel costs are estimated to 10\% of the total requested ANR funding.
-% \item [Expenses for inward billing]
-%   The costs justified by internal invoicing procedures are evaluated to 4\% of the total
-%   requested ANR funding.
-% \end {description}
+  {12}{4}
+
 
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@@ -209,5 +132,5 @@
 \ressourcesForAcademic
  {inria_compsys}{}
- {{\lip}{46}{21}{Christophe Alias and Paul Feautrier}{\mustbecompleted{100}}{
+ {{\lip}{46}{21}{Christophe Alias and Paul Feautrier}{82}{
    \\We are looking for a candidate with both theoretical and
    practical skills, that will be able to get a sufficient
@@ -219,39 +142,4 @@
    }}
  {12}{4}
-%
-% \begin{description}
-% \item [Equipment]
-%   No specific equipment acquisition. The costs for depreciation of
-%   workstations is evaluated to 4\% of the total requested ANR funding.
-% \item [Personnel costs] The faculty members involved in the project
-%   are Christophe Alias (INRIA researcher) and Paul Feautrier (emeritus
-%   professor at ENS-Lyon). The non-permanent personel required is a
-%   post-doc that will work on FIFO construction, then on extensions of
-%   process construction and memory optimization to non-polyhedral
-%   loops.  We are looking for a candidate with both theoretical and
-%   practical skills, that will be able to get a sufficient
-%   understanding of the polyhedral techniques to produce a working
-%   implementation.
-%   \parlf
-%   The table below summarizes the \hommemois by tasks for both permanent
-%   and non-permanent personnels.
-%   Annexe~\ref{table-livrables-lip} (page \pageref{table-livrables-lip})
-%   details this table at the deliverable level.
-%   The effort of permanent personnels represents 61\% of
-%   the total effort. The non-permanent personnels costs represents
-%   52\% of the personal costs. The requested funding for non permanent
-%   personnels is 100\% of the total ANR requested
-%   funding.
-%   \begin{center}\input{table_inria_compsys_short.tex}\end{center}
-% \item [Subcontracting]
-%   No subcontracting costs.
-% \item [Travel]
-%   The travel costs are associated to project meeting as well as
-%   participation to conferences. The travel costs are estimated to 20\%
-%   of the total requested ANR funding.
-% \item [Expenses for inward billing]
-%   The costs justified by internal invoicing procedures are evaluated
-%   to 4\% of the total requested ANR funding.
-% \end{description}
 
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@@ -264,38 +152,4 @@
     }}
  {10}{4}
-%
-% \begin{description}
-% \item [Equipment]
-%   No specific equipment acquisition. 
-% \item [Personnel costs]
-%   The permanent personnels involved in the project are professor and associate professor
-%   (Fr\'ed\'eric P\'etrot and Olivier Muller).
-%   The non permanent personnels are Phd students and post-doc researchers.
-%   Related costs are estimated in \hommemois.
-%   One phd student (Adrien Prost-Boucle), funded by the French ministry of research, will
-%   be working on the project.
-%   One 100\% funded phd student will be hired in September 2011.
-%   A post-doc researcher will be hired at the end of 2012 for one year.
-%   The PhD student will mainly work on the evolution of UGH HLS tool. Thus, we are looking
-%   for a profile with strong informatic skills and good knowledge in computer architecture.
-%   The post-doc will mainly work on HPC. The required profile
-%   will be more oriented on computer architecture and advanced digital design.
-%   \parlf
-%   The table below summarizes the man power in \hommemois by tasks for both permanent and
-%   non-permanent personnels. The detail by deliverables is given in
-%   annexe~\ref{table-livrables-tima} (page \pageref{table-livrables-tima}).
-%   The effort of permanent personnels represents 50\% of the total effort.
-%   The requested funding for non permanent personnels is 86\% of the total ANR requested
-%   funding.
-%     \begin{center}\input{table_tima_short.tex}\end{center}
-% \item [Subcontracting]
-%   No subcontracting costs.
-% \item [Travel]
-%   The travel costs are associated to project meeting as well as participation to
-%   conferences. The travel costs are estimated to 10\% of the total requested ANR funding.
-% \item [Expenses for inward billing]
-%   The costs justified by internal invoicing procedures are evaluated to 4\% of the total
-%   requested ANR funding.
-% \end{description}
 
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@@ -308,33 +162,4 @@
    }}
  {10}{4}
-% 
-% \begin{description}
-% \item [Equipment]
-%   No specific equipment acquisition. 
-% \item [Personnel costs] The faculty members involved in the project
-%   are FranÃ§ois Charot (INRIA researcher) and Steven Derrien (associate
-%   professor).
-%   The non-permanent personal required is a PhD
-%   student that will mainly work on ASIP generation. We are looking for
-%   a profile with strong informatic skills and good knowledge in
-%   computer architecture.
-%   \parlf
-%   The table below summarizes the manpower in \hommemois by tasks for both permanent and
-%   non-permanent personnels. The detail by deliverables is given in
-%   annexe~\ref{table-livrables-inria} (page \pageref{table-livrables-inria}).
-%   The non-permanent personnels costs represent {48\%} of the personnal
-%   costs. The requested funding for non permanent personnels is 100\% of
-%   the total ANR requested funding.
-%     \begin{center}\input{table_inria_cairn_short.tex}\end{center}
-% \item [Subcontracting]
-%   No subcontracting costs.
-% \item [Travel]
-%   The travel costs are associated to project meeting as well as participation to
-%   conferences. The travel costs are estimated to {7,5\%} of the total
-%   requested ANR funding.
-% \item [Expenses for inward billing]
-%   The costs justified by internal invoicing procedures are evaluated to 4\% of the total
-%   requested ANR funding.
-% \end{description}
 
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@@ -353,24 +178,4 @@
     and an engineer  for 27 \hommemois.}
   {10}{5}
-
-% \begin{description}
-% \item[Equipment]
-%     Acquisition of a FPGA development board will represent the main equipment cost for
-%     Bull in COACH. It is estimated at about 5\% (tbc) of the total funding.
-% \item[Personnel costs]
-%     A permanent engineer will be assigned full time to the project for a duration of 36
-%     months as shown in the table below that summarizes the man power in \hommemois.
-%     The detail  by deliverables is given in
-%     annexe~\ref{table-livrables-bull} (page \pageref{table-livrables-bull}).
-%     \begin{center}\input{table_bull_short.tex}\end{center}
-% \item[Subcontracting]
-%     No subcontracting costs.
-% \item[Travel]
-%     Application of a standard 10\% of the total funding to travel costs.
-% \item[Expenses for inward billing]
-%     Costs justified by inward billing are estimated to about 5\% of the total funding.
-% \item[Other working costs] none
-% \end{description}
-
 
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%