Index: trunk/platforms/tsar_generic_xbar/tsar_xbar_cluster/caba/source/src/tsar_xbar_cluster.cpp
===================================================================
--- trunk/platforms/tsar_generic_xbar/tsar_xbar_cluster/caba/source/src/tsar_xbar_cluster.cpp	(revision 378)
+++ trunk/platforms/tsar_generic_xbar/tsar_xbar_cluster/caba/source/src/tsar_xbar_cluster.cpp	(revision 379)
@@ -102,5 +102,5 @@
     { 
         std::ostringstream sproc;
-        sproc << "proc_" << x_id << "_" << y_id << "_" << p;
+        sproc << "proc_" << p;
         proc[p] = new VciCcVCacheWrapper<vci_param, iss_t>(
                       sproc.str().c_str(),
@@ -133,8 +133,6 @@
     std::cout << "  - building memc_" << x_id << "_" << y_id << std::endl;
 
-    std::ostringstream smemc;
-    smemc << "memc_" << x_id << "_" << y_id;
     memc = new VciMemCache<vci_param>(
-                     smemc.str().c_str(),
+                     "memc",
                      mtd,                                // Mapping Table direct space
                      mtx,                                // Mapping Table external space
@@ -150,8 +148,6 @@
                      memc_debug_ok );
 
-    std::ostringstream swtm;
-    swtm << "wt_memc_" << x_id << "_" << y_id;
     wt_memc = new VciDspinTargetWrapper<vci_param,cmd_width,rsp_width>(
-                     swtm.str().c_str(),
+                     "wt_memc",
                      x_width + y_width + l_width);
 
@@ -159,26 +155,16 @@
     std::cout << "  - building xram_" << x_id << "_" << y_id << std::endl;
 
-    std::ostringstream sxram;
-    sxram << "xram_" << x_id << "_" << y_id;
     xram = new VciSimpleRam<vci_param>(
-                     sxram.str().c_str(),
+                     "xram",
                      IntTab(cluster_id),
                      mtx,
                      loader,
                      xram_latency);
-/*
-    std::ostringstream swtx;
-    swtx << "wt_xram_" << x_id << "_" << y_id;
-    wt_xram = new VciDspinTargetWrapper<vci_param,cmd_width,rsp_width>(
-                     swtx.str().c_str(),
-                     x_width + y_width );
-*/
+
     /////////////////////////////////////////////////////////////////////////////
     std::cout << "  - building xicu_" << x_id << "_" << y_id << std::endl;
 
-    std::ostringstream sicu;
-    sicu << "xicu_" << x_id << "_" << y_id;
     xicu = new VciXicu<vci_param>(
-                     sicu.str().c_str(),
+                     "xicu",
                      mtd,                               // mapping table
                      IntTab(cluster_id, tgtid_xicu),    // TGTID_D
@@ -188,8 +174,6 @@
                      nb_procs);                         // number of output IRQs
 
-    std::ostringstream swtu;
-    swtu << "wt_xicu_" << x_id << "_" << y_id;
     wt_xicu = new VciDspinTargetWrapper<vci_param,cmd_width,rsp_width>(
-                     swtu.str().c_str(),
+                     "wt_xicu",
                      x_width + y_width + l_width);
 
@@ -197,24 +181,18 @@
     std::cout << "  - building mdma_" << x_id << "_" << y_id << std::endl;
 
-    std::ostringstream sdma;
-    sdma << "dma_" << x_id << "_" << y_id;
     mdma = new VciMultiDma<vci_param>(
-                     sdma.str().c_str(),
+                     "mdma",
                      mtd,
                      IntTab(cluster_id, nb_procs),        // SRCID
                      IntTab(cluster_id, tgtid_mdma),      // TGTID
                      64,                                  // burst size
-                     nb_dmas);                           // number of IRQs
-
-    std::ostringstream swta;
-    swta << "wt_mdma_" << x_id << "_" << y_id;
+                     nb_dmas);                            // number of IRQs
+
     wt_mdma = new VciDspinTargetWrapper<vci_param,cmd_width,rsp_width>(
-                     swtu.str().c_str(),
-                     x_width + y_width + l_width);
-
-    std::ostringstream swia;
-    swia << "wi_mdma_" << x_id << "_" << y_id;
+                     "wt_mdma",
+                     x_width + y_width + l_width);
+
     wi_mdma = new VciDspinInitiatorWrapper<vci_param,cmd_width,rsp_width>(
-                     swtu.str().c_str(),
+                     "wi_mdma",
                      x_width + y_width + l_width);
 
@@ -230,8 +208,6 @@
     }
 
-    std::ostringstream sdcmd;
-    sdcmd << "xbar_cmd_d_" << x_id << "_" << y_id;
     xbar_cmd_d = new DspinLocalCrossbar<cmd_width>(
-                     sdcmd.str().c_str(),
+                     "xbar_cmd_d",
                      mtd,                          // mapping table
                      x_id, y_id,                   // cluster coordinates
@@ -246,8 +222,6 @@
     std::cout << "  - building xbar_rsp_d_" << x_id << "_" << y_id << std::endl;
 
-    std::ostringstream sdrsp;
-    sdrsp << "xbar_rsp_d_" << x_id << "_" << y_id;
     xbar_rsp_d = new DspinLocalCrossbar<rsp_width>(
-                     sdrsp.str().c_str(),
+                     "xbar_rsp_d",
                      mtd,                          // mapping table
                      x_id, y_id,                   // cluster coordinates
@@ -262,8 +236,6 @@
     std::cout << "  - building xbar_m2p_c" << x_id << "_" << y_id << std::endl;
 
-    std::ostringstream sccmd;
-    sccmd << "xbar_m2p_c_" << x_id << "_" << y_id;
     xbar_m2p_c = new DspinLocalCrossbar<cmd_width>(
-                     sccmd.str().c_str(),
+                     "xbar_m2p_c",
                      mtd,                          // mapping table
                      x_id, y_id,                   // cluster coordinates
@@ -278,24 +250,20 @@
     std::cout << "  - building xbar_p2m_c_" << x_id << "_" << y_id << std::endl;
 
-    std::ostringstream scrsp;
-    scrsp << "xbar_p2m_c_" << x_id << "_" << y_id;
     xbar_p2m_c = new DspinLocalCrossbar<rsp_width>(
-                     scrsp.str().c_str(),
+                     "xbar_p2m_c",
                      mtd,                          // mapping table
                      x_id, y_id,                   // cluster coordinates
-                     x_width, y_width, 0,          // l_width unused on the network going from proc to memc (only X and Y identifie the cluster)
+                     x_width, y_width, 0,          // l_width unused on p2m network
                      nb_procs,                     // number of local sources
                      1,                            // number of local dests
                      2, 2,                         // fifo depths  
                      false,                        // don't use local routing table
-                     false );                      // no broacast
+                     false );                      // no broacast 
 
     /////////////////////////////////////////////////////////////////////////////
     std::cout << "  - building router_cmd_" << x_id << "_" << y_id << std::endl;
 
-    std::ostringstream scmdr;
-    scmdr << "router_cmd_" << x_id << "_" << y_id;
     router_cmd = new VirtualDspinRouter<cmd_width>(
-                     scmdr.str().c_str(),
+                     "router_cmd",
                      x_id,y_id,                    // coordinate in the mesh
                      x_width, y_width,             // x & y fields width
@@ -305,8 +273,6 @@
     std::cout << "  - building router_rsp_" << x_id << "_" << y_id << std::endl;
 
-    std::ostringstream srspr;
-    srspr << "router_rsp_" << x_id << "_" << y_id;
     router_rsp = new VirtualDspinRouter<rsp_width>(
-                     srspr.str().c_str(),
+                     "router_rsp",
                      x_id,y_id,                    // coordinates in mesh
                      x_width, y_width,             // x & y fields width